package com.glxp.mipsdl.entity.hlfyyy;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 药品产品信息查询
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@TableName(value = "v_a003")
public class VA003 implements Serializable {
    @TableField(value = "LASTUPDATETIME")
    private String lastupdatetime;

    @TableField(value = "CODE")
    private String code;

    @TableField(value = "NAME")
    private String name;

    @TableField(value = "NAMECODE")
    private String namecode;

    @TableField(value = "MEASNAME")
    private String measname;

    @TableField(value = "BZGG")
    private String bzgg;

    @TableField(value = "PACKUNIT")
    private String packunit;

    @TableField(value = "PREPNSPEC")
    private String prepnspec;

    @TableField(value = "PREPNUNIT")
    private String prepnunit;

    @TableField(value = "ZXBZSL")
    private String zxbzsl;

    @TableField(value = "REGISTERNO")
    private String registerno;

    @TableField(value = "MANUFACTORYCODE")
    private String manufactorycode;

    @TableField(value = "MANUFACTORY")
    private String manufactory;

    @TableField(value = "SUPCODE")
    private String supcode;

    @TableField(value = "SUPNAME")
    private String supname;

    @TableField(value = "CPLB")
    private String cplb;

    @TableField(value = "FLBM")
    private String flbm;

    @TableField(value = "YBBM")
    private String ybbm;

    @TableField(value = "SPTM")
    private String sptm;

    @TableField(value = "TYSHXYDM")
    private String tyshxydm;

    @TableField(value = "CPMS")
    private String cpms;

    @TableField(value = "SPMC")
    private String spmc;

    @TableField(value = "ZCZYXQZ")
    private String zczyxqz;

    @TableField(value = "PRICE")
    private String price;

    @TableField(value = "RETAILPRICE")
    private String retailprice;

    @TableField(value = "INVCODE")
    private String invcode;

    @TableField(value = "REMARK")
    private String remark;

    @TableField(value = "REMARK1")
    private String remark1;

    @TableField(value = "REMARK2")
    private String remark2;

    @TableField(value = "REMARK3")
    private String remark3;

    private static final long serialVersionUID = 1L;
}
