package com.glxp.mipsdl.entity.hlfyyy;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 药品处方查询
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@TableName(value = "v_a010")
public class VA010 implements Serializable {
    @TableField(value = "CODE")
    private String code;

    @TableField(value = "SICKCODE")
    private String sickcode;

    @TableField(value = "SICKNAME")
    private String sickname;

    @TableField(value = "PRESCRIBEDATE")
    private String prescribedate;

    @TableField(value = "CREATEDR")
    private String createdr;

    @TableField(value = "AMOUNT")
    private String amount;

    @TableField(value = "DEPTCODE")
    private String deptcode;

    @TableField(value = "DEPTNAME")
    private String deptname;

    @TableField(value = "DIAGNOSIS")
    private String diagnosis;

    @TableField(value = "REMARK")
    private String remark;

    private static final long serialVersionUID = 1L;
}
