package com.glxp.mipsdl.entity.hlfyyy;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 药品处方退费查询-明细
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@TableName(value = "v_a011_mx")
public class VA011Mx implements Serializable {
    @TableField(value = "CODEFK")
    private String codefk;

    @TableField(value = "THRID")
    private String thrid;

    @TableField(value = "ITEMNAME")
    private String itemname;

    @TableField(value = "ITEMCODE")
    private String itemcode;

    @TableField(value = "MEASURECOUNT")
    private String measurecount;

    @TableField(value = "MEASUREUNIT")
    private String measureunit;

    @TableField(value = "CATEGORY")
    private String category;

    @TableField(value = "FREQUENCY")
    private String frequency;

    @TableField(value = "COUNT")
    private String count;

    @TableField(value = "BZGG")
    private String bzgg;

    @TableField(value = "PACKUNIT")
    private String packunit;

    @TableField(value = "PREPNSPEC")
    private String prepnspec;

    @TableField(value = "PREPNUNIT")
    private String prepnunit;

    @TableField(value = "MEASNAME")
    private String measname;

    @TableField(value = "PRICE")
    private String price;

    @TableField(value = "RETAILPRICE")
    private String retailprice;

    @TableField(value = "AMOUNT")
    private String amount;

    @TableField(value = "REMARK")
    private String remark;

    @TableField(value = "DRUGLIST")
    private String druglist;

    private static final long serialVersionUID = 1L;
}
