package com.glxp.mipsdl.entity.lhsyy;

import lombok.Data;

import java.math.BigDecimal;

@Data
public class MaterialDictEntity {

    private String materialCode;


    /**
     * 材料类别
     */
    private Integer dlid;
    /**
     * 材料分类ID
     */
    private Integer flid;

    /**
     * 材料小类ID
     */
    private Integer xlid;

    /**
     * 耗材名称
     */
    private String ypspm;

    private Integer cd;

    /**
     * 规格
     */
    private String gg;

    /**
     * 型号
     */
    private String xh;


    private Integer dw;
    /**
     * 剂量单位(小单位)
     */
    private Integer dw1;


    /**
     * 换算关系
     */
    private BigDecimal hsgx;

    /**
     * 医保编码
     */
    private String ybbm;

    /**
     * 零售价
     */
    private BigDecimal lsj;
    private BigDecimal pfj;




    /**
     * 注册文号
     */
    private String pzwh;

    /**
     * 供货单位
     */
    private Integer ghdw;


    /**
     * 病案名称ID
     */
    private String healthcode;

    /**
     * 医保结算（0:N，1:Y）
     */
    private String ybjsqr;

    /**
     * 是否组合套（0:否，1:是）
     */
    private Integer sfzht;

    /**
     * 国家医保编码
     */
    private String gjhcbm;


    /**
     * 是否医保范围（0:否，1:是）
     */
    private Integer sfybfw;



}
