package com.glxp.mipsdl.req.drugMachine;

import lombok.Data;

import java.util.Date;

@Data
public class SendGoodsB002Request {


    /**
     * 记录号
     */
    private String orderId;

    /**
     * 处方单号（可选）
     */
    private String prescribeNum;

    /**
     * 收货方（可选）
     */
    private String fromCorp;

    /**
     * 轨道编号
     */
    private String queueCode;

    /**
     * 产品编码
     */
    private String productCode;

    /**
     * 产品通用名称
     */
    private String productName;

    /**
     * 发药时间
     */
    private Date disTime;

    /**
     * 数量
     */
    private Integer count;

    /**
     * 包装规格（可选）
     */
    private String bzgg;

    /**
     * 计量单位（可选）
     */
    private String unit;

    /**
     * 批准文号（可选）
     */
    private String approvalNum;

    /**
     * 制剂单位（可选）
     */
    private String prepnUnit;

    /**
     * 制剂规格（可选）
     */
    private String prepnSpec;

    /**
     * 备用字段1（可选）
     */
    private String remark1;

    /**
     * 备用字段2（可选）
     */
    private String remark2;

    /**
     * 备用字段3（可选）
     */
    private String remark3;

    /**
     * 备用字段4（可选）
     */
    private String remark4;

    /**
     * 备用字段5（可选）
     */
    private String remark5;
}
