package com.glxp.mipsdl.res;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 简单的分页返回对象
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class PageSimpleResponseNew<T> {
    // 总数
    private Integer total;
    // 列表
    private List<T> list;

    public void setTotal(Long total) {

        this.total = total.intValue();
    }
    public void setTotal(Integer total) {

        this.total = total.intValue();
    }
}
