package com.glxp.mipsdl.service.hlfyyy;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.glxp.mipsdl.entity.hlfyyy.VA010;
import com.glxp.mipsdl.req.base.UdiwmsWarehouseRequest;
import com.glxp.mipsdl.res.PageSimpleResponse;
import com.glxp.mipsdl.res.PageSimpleResponseNew;
import com.glxp.mipsdl.thirddao.hlfyyy.VA004Mapper;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.glxp.mipsdl.entity.hlfyyy.VA004;

import javax.annotation.Resource;
import java.util.List;

@Service
public class VA004Service extends ServiceImpl<VA004Mapper, VA004> {
    @Resource
    private VA004Mapper va004Mapper;
    public PageSimpleResponseNew<VA004> filterList(UdiwmsWarehouseRequest udiwmsWarehouseRequest){
        Page page = new Page<VA010>(udiwmsWarehouseRequest.getPage(), udiwmsWarehouseRequest.getLimit());
        List list =  va004Mapper.filterList(page,udiwmsWarehouseRequest);
        PageSimpleResponseNew<VA004> pageSimpleResponseNew = new PageSimpleResponseNew<>();
        pageSimpleResponseNew.setList(list);
        pageSimpleResponseNew.setTotal(list.size());
        return pageSimpleResponseNew;
    }
}
